Subject: How to partition a PCI device within OF?

From: "Steven A. Falco" <[email-masked]>
Date: Mon, 24 Nov 2008 14:08:02 -0500

I have an FPGA that will be on the PCI bus of a PPC440 processor.
The FPGA unfortunately can only have one "PCI function" (thus one
vendor/device code).  The unfortunate part is that the FPGA has
several logical functions, that should have separate drivers.

Is there a way that I can break out the single PCI device into
several different sub-functions, with separate "sub-function
drivers" using the OF infrastructure?

What I'd like to do is pci_register_driver() once for the whole
device, and when probed by the PCI subsystem, create several OF
viewable sub-devices.  Then, I could have separate OF drivers bind
to the newly created OF sub-devices.

If there are any examples of this, I'd appreciate a pointer.  Or
if I'm completely wedged, and there is a better way to handle the
situation, please say so.

	Steve